//This file extends and modifies the model in Gregory De Walque & Thomas Lejeune & Yuliya Rychalovska & Rafael Wouters, 2017.
//"An estimated two-country EA-US model with limited exchange rate pass-through,"
//Working Paper Research 317, National Bank of Belgium.
//<https://ideas.repec.org/p/nbb/reswpp/201703-317.html>. 
//The code is extended by Volha Audzei: adding China, and removing oil sector. 

//Notes: "us" refers to US, flex refers to flexible economy
//"ch" refers to China economy
// _{co} means "towards the country". E.g. export_ea_us - EA export to US
@#define countries = ["us","ch"]
@#define countries2 = ["us","ch"]
@#define countries3 = ["us"]
@#define uslist = ["us"]
@#define chlist = ["ch"]
@#define nth_ch = "ch"
@#define ch = ["ch"]
//***************************************************************
var 
// common variables
//zz
@#for co in countries  
	cbold_@{ co }       	${\textbf{c}}$  (long_name='total consumption')
	cf_@{ co }			${c_F} $		(long_name='foreign consumption good')
    c_@{ co }           	${c}$           (long_name='non-oil consumption')
    inve_@{ co }        	${i}$           (long_name='Investment')
	invf_@{ co }		${i_F}$ 		(long_name='foreign investment good')
    k_@{ co }           	${k_@{co}^{s}}$       (long_name='Capital services') 
	kp_@{ co }          ${k_@{co}}$           (long_name='Capital stock') 
	//mbold_@{ co }		${\textbf{m}}$	(long_name='total imports')
	//mcdelta_@{ co }		${mc^{\Delta}}$ (long_name='Foreign marginal costs in home currency')
    lab_@{ co }         	${l}$           (long_name='hours worked')
    mc_@{ co }            ${MC}$		      (long_name='marginal costs') 
	mh_@{ co }			${m_H}$			(long_name='non-oil imports')
	netx_@{ co }						(long_name='Net export')
	//oil_@{ co }
	pc_@{ co }				${pc}$			(long_name='real value of composite consumption price index') 
	pdf_@{ co }			${p_F^D}$		(long_name='Consumer price of foreign distributed good')
	pftot_@{ co }			${p_F}$		(long_name='Consumer price of foreign (US+RoW) good')
	ph_@{ co }			${p_H}$			 (long_name='Consumer price of home good')
    pinf_@{ co }        	${\pi_h}$         (long_name='home inflation')
	piobj_@{co}
	dpiobj_@{co}
	ctrendev_@{co}
	pinfc_@{ co }        	${\pi}$         (long_name='consumption price inflation')
	pinff_@{ co }       ${\pi_F}$       (long_name='imported inflation')
	pinffp_@{ co }      ${\pi_F^p}$     (long_name='imported inflation for production inputs')
    pk_@{ co }          	${q}$           (long_name='real value of existing capital stock') 
	pmbold_@{ co }		${\textbf{p_m}}$			(long_name='total import price')
	//poild_@{ co }		${p_oil^D}$		(long_name='Distributed Oil Price')
	ppf_@{ co }			${p_F^p}$		(long_name='Foreign Price of production good')
	//px_@{ co }			${p_X}$			(long_name='Export price')
	pxbold_@{ co }			${p_X}$			(long_name='Total export price, including oil')
    r_@{ co }           ${r}$           (long_name='nominal interest rate')
	//rr_@{ co }								 (long_name='real interest rate')
    rk_@{ co }          	${r^{k_@{co}}}$       (long_name='rental rate of capital') 
	xf_@{ co }			${x_F}$			(long_name='demand for transit good')
	xh_@{ co }			${x_H}$			(long_name='exported goods')
    w_@{ co }           ${w}$           (long_name='real wage')
    y_@{ co }           	${y}$           (long_name='Output')
    zcap_@{ co }        	${z}$           (long_name='Capital utilization rate') 
	tb_@{ co }
	//nfa_@{co}
//flexible economy  
	 tbflex_@{co} pftotflex_@{ co } 
	ppfflex_@{ co } pxboldflex_@{ co } 	mcflex_@{ co } 	pcflex_@{ co } 	pmboldflex_@{ co } mcdeltaflex_@{co}
	netxflex_@{ co } 		zcapflex_@{ co } rkflex_@{ co } kflex_@{ co } pkflex_@{ co }
    cflex_@{ co }    kpflex_@{ co }	cboldflex_@{ co }   inveflex_@{ co }     yflex_@{ co } labflex_@{ co }    wflex_@{ co } 
    rrflex_@{ co } 	cfflex_@{ co } invefflex_@{ co } xfflex_@{ co } xhflex_@{ co } mhflex_@{ co } 
@#endfor
//bilateral and country-specific variables
@#for co in countries 
	@#for co2 in countries2
		@# if co != co2
			xf_@{ co }_@{ co2 } xfflex_@{ co }_@{ co2 }  yfb_@{ co }_@{ co2 } yfbflex_@{ co }_@{ co2 }
			xhb_@{ co }_@{ co2 } mhb_@{ co }_@{ co2 }
			xhbflex_@{ co }_@{ co2 } mhbflex_@{ co }_@{ co2 } totflex_@{ co }_@{ co2 }
			cfb_@{ co }_@{ co2 }			${c_F} $		(long_name='bilateral foreign consumption good')
			tot_@{ co }_@{ co2 } ppfflex_@{ co }_@{ co2 }
			pmbold_@{ co }_@{ co2 } pmboldflex_@{ co }_@{ co2 } pxbold_@{ co }_@{ co2 } pxboldflex_@{ co }_@{ co2 }
			pfb_@{ co }_@{ co2 } pfbflex_@{ co }_@{ co2 }
		@# endif
	@#endfor
@#endfor
	 cfflexb_us_ch  cfflexb_ch_us
//	eempl_ea						(long_name='aux variable for employment observation eq')
	    invefflexb_us_ch  invefflexb_ch_us
	 invfb_us_ch  invfb_ch_us    ${i_F}$ 		(long_name='bilateral foreign investment good')
	 pinffb_us_ch  pinffb_ch_us		(long_name='imported bilateral inflation')				
	 pinffp_us_ch  pinffp_ch_us
	 pinfx_us_ch  pinfx_ch_us
	 pinfxp_us_ch  pinfxp_ch_us
	 ppf_us_ch  ppf_ch_us
	  px_us_ch  px_ch_us		
	 pxflex_us_ch  pxflex_ch_us     ${p_X}$			(long_name='Bilateral export price')
	 pxp_us_ch  pxp_ch_us	
	 pxpflex_us_ch  pxpflex_ch_us   ${p_X^p}$			(long_name='Bilateral export price production good')
	 rs_us_ch  rs_ch_us	
	 rsflex_us_ch  rsflex_ch_us    ${rs}$			(long_name='Real exchange rate, Euro/Dollar or Euro/YEN')
	nfa_ch
	nfaflex_ch
@#for co in countries
	@#for co2 in countries2
		@# if co != co2
			xcrtrend_@{ co }_@{ co2 }
		@#endif			
	@#endfor			
@#endfor			
// Shocks
@#for co in countries  	
    a_@{ co }           ${\varepsilon_a}$(long_name='productivity process')
    b_@{ co }           ${c_2*\varepsilon_t^b_@{co}}$ 
								(long_name='Scaled risk premium shock')
    g_@{ co }           ${\varepsilon^g}$(long_name='Exogenous spending')
    qs_@{ co }          ${\varepsilon^i}$(long_name='Investment-specific technology')
    ms_@{ co }          ${\varepsilon^r}$(long_name='Monetary policy shock process') 
    spinf_@{ co }       ${\varepsilon^{pH}}$
								(long_name='Price markup shock process')
    sw_@{ co }          ${\varepsilon^w}$(long_name='Wage markup shock process')
	spinff_@{ co }      ${\varepsilon^{pF}}$
								(long_name='Price markup shock process in imported inflation')
	snt_@{ co }			${\varepsilon^nt}$   (long_name='Rest of the world demand shock')
	sp_@{ co }			${\varepsilon^p}$	   (long_name='consumer price shock')
	epinfma_@{ co } 
	epinffma_@{co}	
	ewma_@{co}
@#endfor
	ss_us_ch  ss_ch_us
	rstrenddev_ch_us
//processes for tariffs:
	tarif_us_lim_ch		(long_name='US imposes tariffs on China without retaliation')
	tarif_us_sym_ch		(long_name='US and China impose symmetric tariffs on each other')
	tt_ch_us tt_us_ch		(long_name='bilateral trade balances')
//observables
@#for co in countries3
    dWC_@{ co }   dMTD_@{co}
@#endfor

@#for co in countries
dYER_@{ co } dITR_@{ co } dPCR_@{ co } dYED_@{ co } dinftrend_@{ co } dPCD_@{ co } NETTRADE_@{ co }
@#endfor
dLAB_us  FEDFUND_us  
dEXCRN_ch_us   STI_ch    
;
varexo 
// home

	
  @#for co in countries  
  ea_@{ co }       	${\mu^a}$      (long_name='Productivity shock')
	eb_@{ co }          ${\mu^b_@{co}}$      (long_name='Risk-premium shock')
	eg_@{ co }          ${\mu^g}$      (long_name='Spending shock')
    eqs_@{ co }         ${\mu^i}$      (long_name='Investment-specific technology shock')
    em_@{ co }          ${\mu^m}$      (long_name='Monetary policy shock')
    epinf_@{ co }       ${\mu^{p}}$    (long_name='Price markup shock')  
    ew_@{ co }          ${\mu^{w}}$    (long_name='Wage markup shock')
	ep_@{ co }			${\mu^p}$	   (long_name='Consumer price shock')
	ent_@{ co }			${\mu^nt}$	   (long_name='Rest of the world demand shock')
	epinff_@{ co }  			${\mu*^{pF}}$    (long_name='Foreign Price markup shock')
    //econstepinf_@{ co }					(long_name='Deviation from trend')
    epiobj_@{ co }					(long_name='Deviation from trend')
	ectrenddev_@{co}			(long_name='Deviation of trend growth from trend')		
	@#endfor	
//international
	 es_us_ch
	erstrenddev
	excrtrend
	//e_trend_ch 	(long_name='deviation of Chinas RS trend from steady state')
	//e_res_ch	(long_name='deviation of Chinas reserve requiments from the steady state')
	e_tarif_us_lim_ch
	e_tarif_us_sym_ch
;
parameters 
// common
@#for co in countries  
    cgy_@{ co }         ${\rho_{ga}}$       (long_name='Feedback technology on exogenous spending')
    curvp_@{ co }       ${\varepsilon_p}$   (long_name='Curvature Kimball aggregator prices')  
    cmaw_@{ co }        ${\nu_w}$           (long_name='coefficient on MA term wage markup')  
    cmap_@{ co }        ${\nu_p}$           (long_name='coefficient on MA term price markup')  
    calfa_@{ co }       ${\alpha}$          (long_name='capital share')
    czcap_@{ co }       ${\psi}$            (long_name='capacity utilization cost')  
    csadjcost_@{ co }   ${\varphi}$         (long_name='investment adjustment cost')  
    ctou_@{ co }        ${\delta}$          (long_name='depreciation rate')  
    csigma_@{ co }      ${\sigma_c}$        (long_name='risk aversion')  
	//cgamma      ${\gamma}$        	(long_name='GDP growth') 
	cdeltaf_@{ co }		${\delta_f}$        (long_name='share of distributed goods in good production')
	//cdeltao_@{ co }		${\delta_o}$        (long_name='share of crude oil in consumption production') 	
    chabb_@{ co }       ${\lambda_hab}$         (long_name='external habit degree')  
    cfc_@{ co }         ${\phi_p}$          (long_name='fixed cost share')  
    cindw_@{ co }       ${\iota_w}$         (long_name='Indexation to past wages')  
    cprobw_@{ co }      ${\xi_w}$           (long_name='Calvo parameter wages')   
    cindp_@{ co }       ${\iota_p}$         (long_name='Indexation to past prices')  
    cprobp_@{ co }      ${\xi_p}$           (long_name='Calvo parameter prices')   
	crhopiobj_@{co}
	crhotrend_@{co}
    crhop_@{co}
	csigl_@{ co }       ${\sigma_l}$        (long_name='Frisch elasticity')   
    clandaw_@{ co }     ${\phi_w}$          (long_name='Gross markup wages')
    crpi_@{ co }        ${r_{\pi}}$         (long_name='Taylor rule inflation feedback') 
    crdy_@{ co }        ${r_{\Delta y}}$    (long_name='Taylor rule output growth feedback') 
    cry_@{ co }         ${r_{y}}$           (long_name='Taylor rule output level feedback') 
    crr_@{ co }         ${\rho}$            (long_name='interest rate persistence')  
    crhoa_@{ co }       ${\rho_a}$          (long_name='persistence productivity shock')  
    crhob_@{ co }       ${\rho_b}$          (long_name='persistence risk premium shock')  
    crhog_@{ co }       ${\rho_g}$          (long_name='persistence spending shock')  
    crhoqs_@{ co }      ${\rho_i}$          (long_name='persistence of investment shock')  
    crhoms_@{ co }      ${\rho_r}$          (long_name='persistence monetary policy shock')  
    crhopinf_@{ co }    ${\rho_p}$          (long_name='persistence price markup shock, AR')  
	crhow_@{ co }       ${\rho_w}$          (long_name='persistence wage markup shock')
	crom_@{ co }		${\rho_m}$ 			(long_name='share of imported goods in production') 
	//croo_@{ co }		${\rho_oil}$			(long_name='share of oil in production')
	//cphioil_@{ co }		${\phi_oil}$			(long_name='oil share in consumption')
	clambda_@{ co }		${\lambda}$	        (long_name='trade elasticity of substitution between domestic and foreign goods')
	clambdaw_@{ co }	${\lambda_w}$	    (long_name='wage elasticity')
	cy_@{ co }		${\frac(\overbar{\textbf{c}})(\overbar{y})}$
									(long_name='steady state consumption to gdp')
	iy_@{ co }		${\frac(\overbar{i})(\overbar{y})}$ 
									(long_name='steady state investment to gdp')
	gy_@{ co }		${\frac(\overbar{g})(\overbar{y})}$
									(long_name='steady state gov spending to gdp')						
	cnup_@{ co }		${\nu_p}$	    	(long_name='reaction of home inflation to consumption price shocks')
//open economy-home
	clambdax_@{ co }	${\lambda_x}$		(long_name='trade elasticity of substitution between total foreign exports and domestic transit goods')
	clambdaim_@{ co }		${\lambda}$	        (long_name='trade elasticity of substitution between different foreign goods')
	comega_@{ co }		${\Omega}$			(long_name='adjustment costs of using imported good')
	comegaim_@{ co }		${\Omega}$		(long_name='adjustment costs of different imported goods')
	cronfa_@{ co }   	${\rho_{nfa}}$    	(long_name='Auxiliary parameter to insure stationarity')
	cnua_@{ co }	    ${\nu_a}}$          (long_name='reaction of export to TFP')
	crhopinff_@{ co }   ${\rho_pF}$         (long_name='persistence foreign price markup shock, AR')  
	cmapf_@{ co }       ${\nu_{pF}}$        (long_name='coefficient on MA foreign term price markup')
	cprobpf_@{ co }		${\xi_{pF}}$        (long_name='Calvo import prices')
	cindpf_@{ co }		${\iota_{pF}}$      (long_name='Calvo index import prices')
	cront_@{ co }		${\rho_{nt}}}$        (long_name='ROW demand AR parameter')
	McontX_@{ co }
	comegax_@{co}
//trends
    ctrend_@{ co }      ${\bar \delta}$     (long_name='net growth rate in percent')  
	constepinf_@{ co } 						(long_name='trend in inflation')  
	constem_@{ co }		(long_name='trend in import prices') 
	constelab_@{ co } 	(long_name='trend in hours worked') 
	constent_@{ co } (long_name='trend in net export') 
	constbeta_@{ co } 
	crhoeer_@{ co }
@#endfor			
	 cbetam_us_ch  cbetam_ch_us    ${\betta_m}$			(long_name='Sensitivity of home imports to foreign imports')
	 cbetax_us_ch  cbetax_ch_us    ${\betta_x}$		(long_name='Sensitivity of home exports to foreign imports')
	consters_ch_us	 (long_name='trend in real exchange rate')
	//constreq
//open economy	
	crhoss_us_ch	    ${\rho_s}$          (long_name='persistence UIRP exchange rate shock') 	  
	cthetas_us_ch   ${\theta_s}}$    (long_name='UIRP smoothing parameter')
	cthetauip_ch_us
	cruip_ch		(long_name='Taylor rule parameter currency basket deviation from trend')  
	crhoxcrtrend
	;
//******************************************************************************************
//Parameters initialisation
//******************************************************************************************	
//US economy
//********************************************************	
// fixed parameters
ctou_us			=.025; %
curvp_us		=10;%
cy_us			=0.645;%
iy_us			=0.173;%
gy_us			=0.160;%
clambdaw_us		=0.250; %
clandaw_us		=clambdaw_us; %
//trends
ctrend_us			=0.3752;
constbeta_us		=0.405;
constelab_us		=-0.0345;
constepinf_us		=0.5; %trend in home inflation
constent_us     	=-2.8;
constem_us 			=0.5266;
//behavior parameters
calfa_us			=.2711; %
csigma_us			=1.0898	; %
cfc_us				=1.4511;%
csadjcost_us		= 4.9596;%
chabb_us			=0.707;%    
cprobw_us			=0.739;%
csigl_us			=2.5802;%
cprobp_us			=0.8329;%
cindw_us			=0.39;%
cindp_us			=0.3414;%
czcap_us			=0.7;%
//Taylor
crpi_us				= 1.4;%
crr_us				=0.87;%
cry_us				=0.0565;%
crdy_us				= 0.151;%
//persistence of shocks
crhoa_us			=0.9738;%
crhob_us			=0.7075;%
crhog_us			=0.9386;%
crhoqs_us			=0.9139;%
crhoms_us			=0.1201;%
crhopinf_us			=0.8805;%
crhopiobj_us		=0.9;
crhotrend_us		=0.9;
crhop_us		=0.9;
crhow_us			=0.9613;%
cront_us			=0.941;%
crhoeer_us			=0.9;
crhoss_us_ch		=0.7609;%
cnua_us				=0.8306;%
cnup_us				=0.3;
cmap_us 			= 0.8097;%
cmaw_us 			= 0.9;%
cgy_us				=0.5362;
crhopinff_us	=0.9611;
cmapf_us		=0.4496;
crhoeer_us_ch		=0.9;
//structural parameters
crom_us				=0.08;%
cdeltaf_us			=0.4718;%
cbetax_us_ch		=0.08;% //average 2001-2016, https://wits.worldbank.org/CountryProfile/en/Country/USA/StartYear/1991/EndYear/2016/TradeFlow/Export/Partner/CHN/Indicator/XPRT-PRTNR-SHR
cbetam_us_ch		=0.20;%
clambda_us			=1.799;%
cprobpf_us			=0.3519;%
cindpf_us			=0.3687;%
comega_us			=4.3508;%
cronfa_us		=10^(-7);
clambdax_us		=0;
McontX_us       = 0.12500;
//****************************************************
//China economy
//****************************************************
// fixed parameters
ctou_ch			=.025; %
curvp_ch		=10;%
cy_ch			=0.5;%//%calibrated from excel
iy_ch			=0.4;%//%calibrated from excel, average?
gy_ch			=0.160;%
clambdaw_ch		=0.250; %
clandaw_ch		=clambdaw_ch; %
ctrend_ch			=2.7; % estimates of Li (2017)   
constbeta_ch		=0.3496;
constelab_ch		=-0.0345;
constepinf_ch		=0.5; %trend in home inflation
constent_ch     	=2;
constem_ch 			=0.5266;
constreq			=1;
//behavior parameters
calfa_ch			=.2711; %
csigma_ch			=0.9898	; %
cfc_ch				=1.4511;% 0 in Li(2017)
csadjcost_ch		= 3.9596;%
chabb_ch			=0.36;% estimates of Li (2017)    
csigl_ch			=2.39;% 1/estimates of Li (2017)  
cprobp_ch			=0.92;% estimates of Li (2017)  
cindp_ch			=0.61;%estimates of Li (2017)  
cprobw_ch			=0.6284;%
cindw_ch			=0.4786;%
czcap_ch			=0.5;%
//Taylor
crpi_ch				= 2.5;%estimates of Li (2017)  
crr_ch				=0.8;%
cry_ch				=0.0565;% estimates of Li (2017)  
crdy_ch				= 0.1789;%
cthetauip_ch_us		=0.7; 
cruip_ch			=0.1;
crhoptrend_ch 	=	0.1;
//persistence of shocks
crhoa_ch			=0.62;%
crhob_ch			=0.7075;%
crhog_ch			=0.9386;%
crhoqs_ch			=0.9139;%
crhoms_ch			=0.1201;%
crhopinf_ch			=0.8805;%
crhopiobj_ch		=0.9;
crhotrend_ch		=0.9;
crhop_ch		=0.9;
crhoxcrtrend		=0.9;
crhow_ch			=0.9613;%
cront_ch			=0.941;%
crhoeer_ch			=0.9;
cnua_ch				=0.8306;%
cnup_ch				=0.5;
cmap_ch 			= 0.8097;%
cmaw_ch 			= 0.4338;%
cgy_ch				=0.5362;
//structural parameters
crom_ch				=0.0751;%
cdeltaf_ch			=0.4718;%
cbetax_ch_us		=0.19;//%from excel file stat.wto.org for 2016 0.18

cbetam_ch_us		=0.08;%//%from excel file stat.wto.org for 2016 0.085
clambda_ch			=1.6993;%
cprobpf_ch			=0.3519;%
cindpf_ch			=0.3687;%
comega_ch			=4.3508;%
cronfa_ch			=10^(-7);
clambdax_ch			=0;
McontX_ch       	= 0.12500;
crhopinff_ch		=0.9611;
cmapf_ch			=0.4496;
//International parameters (based on the posterior estimates from 2-country paper)

cthetas_us_ch 		= 0.2; %//out of the blue
consters_ch_us		=0.4425;
constim_ch 			=1.1;
constexp_ch			=1.1;
@#for co in countries  
clambdax_@{co}=0;
comegax_@{co}=0;
@#endfor
@#for co in countries  
clambdaim_@{co}=clambda_@{co};
comegaim_@{co}=comega_@{co};
@#endfor
//****************************************************************************************	
model(linear);
//***************************************************************************************
#mtoy_us=(1-crom_us)*0.14; //estimate as average of 1995-2016;
#mtoy_ch=(1-crom_ch)*0.2; //rough estimate from data.worldbank.org imports of goods and services, % of gdp;
@#for co in countries  
	#ctoy_@{ co }=(1-crom_@{ co })*cy_@{ co };
	#itoy_@{ co }=(1-crom_@{ co })*iy_@{ co };
	#comegac_@{ co }=comega_@{ co };
	#comegai_@{ co }=comega_@{ co };
	#cgamma_@{ co }=1+ctrend_@{ co }/100; %
	#cbeta_@{ co } = 1/(1+constbeta_@{ co }/100);
	#cbetabar_@{ co }=cbeta_@{ co }*cgamma_@{ co }^(-csigma_@{ co });
	#constepinfc_@{ co }=1+constepinf_@{ co }/100;
	#conster_@{ co }=100*(constepinfc_@{ co }/cbetabar_@{ co }-1);
	# cphixh_@{ co }    =  1 - McontX_@{ co } + crom_@{ co } ;
	#cphih_@{ co }=  1 - (mtoy_@{ co }*cphixh_@{ co } - crom_@{ co })*(1+cdeltaf_@{ co })/(ctoy_@{ co }+itoy_@{ co });
	//#cphimoil_@{ co } =  (croo_@{ co } + cphioil_@{ co }/(1+cdeltao_@{ co })*ctoy_@{ co })/mtoy_@{ co };
	#cphif_@{ co }=((1-cphih_@{ co })*(ctoy_@{ co }+itoy_@{ co })/(1+cdeltaf_@{ co }))/  //quasi-share of imported goods dedicated to direct consumption
			((1-cphih_@{ co })*(ctoy_@{ co }+itoy_@{ co })/(1+cdeltaf_@{ co })+crom_@{ co });
	#cphimh_@{ co }=1 - (1-cphixh_@{ co });
	# celastpdt_@{ co } = (cfc_@{ co }/(cfc_@{ co }-1))*(1+cdeltaf_@{ co })/(1-crom_@{ co });
//	#celastpdt_@{ co } = cfc_@{ co }/(cfc_@{ co }-1);                    
	#crk_@{ co }=(cbeta_@{ co }^(-1))*(cgamma_@{ co }^csigma_@{ co }) - (1-ctou_@{ co });
	#cikbar_@{ co }=(1-(1-ctou_@{ co })/cgamma_@{ co });
	#cky_@{ co }=itoy_@{ co }/cikbar_@{ co };
	#cwhlc_@{ co }=(1/(1+clandaw_@{ co }))*(1-calfa_@{ co })/calfa_@{ co }*crk_@{ co }*cky_@{ co }/ctoy_@{ co };
	#crkky_@{ co }=crk_@{ co }*cky_@{ co };
@#endfor
//********************************************	
//bilateral trade home+foreign
//********************************************	
//sticky price
	//export_ea_us would mean export from ea to us; import_ea_us would mean import to ea from us 
@#for co in countries 
	//%country where to export 
	@#for co2 in countries2 
	// from where to export
		@# if co != co2
//Note that demand for transit good moves one-to-one with total export
			cfb_@{co}_@{co2} =  cf_@{co}- clambdaim_@{co}*( (cphih_@{co}*1/(1+cdeltaf_@{co}))*(pfb_@{co}_@{co2}-ph_@{co}) )
						-comegaim_@{co}*clambdaim_@{co}*(cfb_@{co}_@{co2}-cf_@{co}-(cfb_@{co}_@{co2}(-1)-cf_@{co}(-1))) 
						+ cbeta_@{co}*comegaim_@{co}*clambdaim_@{co}*(cfb_@{co}_@{co2}(+1)-cf_@{co}(+1)-(cfb_@{co}_@{co2}-cf_@{co})) ;
			invfb_@{co}_@{co2} =  invf_@{co}- clambdaim_@{co}*((cphih_@{co}*1/(1+cdeltaf_@{co}))*(pfb_@{co}_@{co2}-ph_@{co}))
						- comegaim_@{co}*clambdaim_@{co}*(invfb_@{co}_@{co2}-invf_@{co}-(invfb_@{co}_@{co2}(-1)-invf_@{co}(-1))) 
						+ cbeta_@{co}*comegaim_@{co}*clambdaim_@{co}*(invfb_@{co}_@{co2}(+1)-invf_@{co}(+1)-(invfb_@{co}_@{co2}-invf_@{co})) ;   
			yfb_@{co}_@{co2} =  y_@{co}/crom_@{co}- clambdaim_@{co}*( ppf_@{co}_@{co2} )
						-comegaim_@{co}*clambdaim_@{co}*(yfb_@{co}_@{co2}-y_@{co}/crom_@{co}-(yfb_@{co}_@{co2}(-1)-y_@{co}(-1)/crom_@{co})) 
						+ cbeta_@{co}*comegaim_@{co}*clambdaim_@{co}*(yfb_@{co}_@{co2}(+1)-y_@{co}(+1)/crom_@{co}-(yfb_@{co}_@{co2}-y_@{co}/crom_@{co})) ;  
			mhb_@{co}_@{co2} = cphimh_@{co}*(((1-cphih_@{co})/(mtoy_@{co}*cphimh_@{co}*(1+cdeltaf_@{co})))
							*(ctoy_@{co}*cfb_@{co}_@{co2} + itoy_@{co}*invfb_@{co}_@{co2}) 
						+ (1-cphif_@{co})*yfb_@{co}_@{co2}) 
						+ (1-cphimh_@{co})*xf_@{co}_@{co2};
			xhb_@{co}_@{co2}= mhb_@{co2}_@{co};			
			xf_@{co}_@{co2} = xh_@{co}-clambdax_@{co}*(-tot_@{co}_@{co2})-clambdax_@{co}*comegax_@{co}*
							(xf_@{co}_@{co2}-xh_@{co}-(xf_@{co}_@{co2}(-1)-xh_@{co}(-1)))+
							cbeta_@{co}*comegax_@{co}*clambdax_@{co}*(xf_@{co}_@{co2}(1)-xh_@{co}(1)-(xf_@{co}_@{co2}-xh_@{co}));			
			tot_@{co}_@{co2}		= pxbold_@{co}_@{co2}-pmbold_@{co}_@{co2};
//flexible prices
			cfflexb_@{co}_@{co2} =  cfflex_@{co}- clambdaim_@{co}*( cphih_@{co}/(1+cdeltaf_@{co})*(pfbflex_@{co}_@{co2}-mcflex_@{co}) )
							- comegaim_@{co}*clambdaim_@{co}*(cfflexb_@{co}_@{co2}-cfflex_@{co}-(cfflexb_@{co}_@{co2}(-1)-cfflex_@{co}(-1))) 
							+ cbeta_@{co}*comegaim_@{co}*clambdaim_@{co}*(cfflexb_@{co}_@{co2}(+1)-cfflex_@{co}(+1)-(cfflexb_@{co}_@{co2}-cfflex_@{co}))        ;  
			invefflexb_@{co}_@{co2}  =  invefflex_@{co}- clambdaim_@{co}*( cphih_@{co}*1/(1+cdeltaf_@{co})*(pfbflex_@{co}_@{co2}-mcflex_@{co}) )
									- comegaim_@{co}*clambdaim_@{co}*(invefflexb_@{co}_@{co2}-invefflex_@{co}-(invefflexb_@{co}_@{co2}(-1)-invefflex_@{co}(-1))) 
									+ cbeta_@{co}*comegaim_@{co}*clambdaim_@{co}*(invefflexb_@{co}_@{co2}(+1)-invefflex_@{co}(+1)-(invefflexb_@{co}_@{co2}-invefflex_@{co}))  ;   
			yfbflex_@{co}_@{co2} =  yflex_@{co}/crom_@{co}- clambdaim_@{co}*( ppfflex_@{co}_@{co2} )
						-comegaim_@{co}*clambdaim_@{co}*(yfbflex_@{co}_@{co2}-yflex_@{co}/crom_@{co}-(yfbflex_@{co}_@{co2}(-1)-yflex_@{co}(-1)/crom_@{co})) 
						+ cbeta_@{co}*comegaim_@{co}*clambdaim_@{co}*(yfbflex_@{co}_@{co2}(+1)-yflex_@{co}(+1)/crom_@{co}-(yfbflex_@{co}_@{co2}-yflex_@{co}/crom_@{co})) ;  
			mhbflex_@{co}_@{co2} = cphimh_@{co}*(((1-cphih_@{co})/(mtoy_@{co}*cphimh_@{co}*(1+cdeltaf_@{co})))*
								(ctoy_@{co}*cfflexb_@{co}_@{co2} + itoy_@{co}*invefflexb_@{co}_@{co2}) 
								+ (1-cphif_@{co})*yfbflex_@{co}_@{co2}) 
								+ (1-cphimh_@{co})*xfflex_@{co}_@{co2}; 
			xfflex_@{co}_@{co2} = xhflex_@{co}-clambdax_@{co}*(-totflex_@{co}_@{co2})-clambdax_@{co}*comegax_@{co}*
								(xfflex_@{co}_@{co2}-xhflex_@{co}-(xfflex_@{co}_@{co2}(-1)-xhflex_@{co}(-1)))+
								cbeta_@{co}*comegax_@{co}*clambdax_@{co}*(xfflex_@{co}_@{co2}(1)-xhflex_@{co}(1)-(xfflex_@{co}_@{co2}-xhflex_@{co}));
			xhbflex_@{co}_@{co2}=mhbflex_@{co2}_@{co};								
			totflex_@{co}_@{co2}	= pxboldflex_@{co}_@{co2}-pmboldflex_@{co}_@{co2};
//Bilateral export and import prices	
//Import price in mix of currencies, we have to translate it to home price, co			
			(celastpdt_@{co}-1)*pfbflex_@{co}_@{co2}   = (celastpdt_@{co}-1-cdeltaf_@{co})*
											(mcflex_@{co2}-rsflex_@{co2}_@{co} )
													+ cdeltaf_@{co}*mcflex_@{co} ;   
			ppfflex_@{co}_@{co2}	= (mcflex_@{co2}-rsflex_@{co2}_@{co});
			
//Export prices in foreign, co2, currency
			(celastpdt_@{co2}-1)*pxflex_@{co}_@{co2}      = (celastpdt_@{co2}-1-cdeltaf_@{co2})*(mcflex_@{co}-rsflex_@{co}_@{co2}) 
												+ cdeltaf_@{co2}*(mcflex_@{co2});
//Export of production good in foreign, co2, currency, but pxbold is already in local, co, currency
			pxpflex_@{co}_@{co2}	  = (mcflex_@{co}-rsflex_@{co}_@{co2}); 
			pxboldflex_@{co}_@{co2}   = (cphixh_@{co}* (cphif_@{co2}*pxflex_@{co}_@{co2}   + (1-cphif_@{co2})*pxpflex_@{co}_@{co2}  
										+ rsflex_@{co}_@{co2}  )
										+(1-cphixh_@{co})*cbetax_@{co}_@{co2}*pftotflex_@{co});
										//+ cphixoil_@{co} *cbetaxoil_@{co}_@{co2}*poilhomeflex_@{co};
			pmboldflex_@{co}_@{co2}=(cphif_@{co}*pfbflex_@{co}_@{co2}+(1-cphif_@{co})*ppfflex_@{co}_@{co2});
										//+cphimoil_@{co}*cbetamoil_@{co}_@{co2}*poilhomeflex_@{co};
		@#endif
	@#endfor
			
		(celastpdt_@{co}-1)*pftotflex_@{co}   = (celastpdt_@{co}-1-cdeltaf_@{co})*(mcdeltaflex_@{co})+ cdeltaf_@{co}*mcflex_@{co} ;        
		ppfflex_@{co}				       	  = mcdeltaflex_@{co};
	
@#endfor 
			
//Aggegate import and export, aggregate export is now in home currency!!!
cbeta_us*nfaflex_ch =  (1/cgamma_ch)*nfaflex_ch(-1) + mtoy_ch*(tbflex_ch);
//nfaflex_us=0;
pxboldflex_us = (cphixh_us*cbetax_us_ch*(cphif_ch*pxflex_us_ch + (1-cphif_ch)*pxpflex_us_ch + rsflex_us_ch)
				+(1-cphixh_us)*pftotflex_us) ;
pxboldflex_ch = (cphixh_ch*cbetax_ch_us*(cphif_us*pxflex_ch_us + (1-cphif_us)*pxpflex_ch_us + rsflex_ch_us)
				+(1-cphixh_ch)*pftotflex_ch) ;
//"Imported" marginal cost in home currency 
mcdeltaflex_us=cbetam_us_ch*(mcflex_ch+rsflex_us_ch);	  
mcdeltaflex_ch=cbetam_ch_us*(mcflex_us+rsflex_ch_us);	  
//International variables
//Real exchange rate
rsflex_ch_us - xcrtrend_ch_us	=	(1-cthetas_us_ch)*(rsflex_ch_us(1)- xcrtrend_ch_us(1))+cthetas_us_ch*(rsflex_ch_us(-1)- xcrtrend_ch_us(-1))
			-(rrflex_ch+cthetauip_ch_us*(rsflex_ch_us - xcrtrend_ch_us))+rrflex_us-cronfa_us*nfaflex_ch
			+ss_ch_us;
rsflex_us_ch=-rsflex_ch_us;
//Effective real exchange rate
//Total export (demand driven)
xhflex_us=cbetax_us_ch*xhbflex_us_ch+snt_us;//++
xhflex_ch=cbetax_ch_us*xhbflex_ch_us+snt_ch;//++
// Individual equations
//Trade balance	
tbflex_us	=	pxboldflex_us-pmboldflex_us+(netxflex_us);	
tbflex_ch	=	pxboldflex_ch-pmboldflex_ch+(netxflex_ch);	
//Symmetric equations
@#for co in countries  
	   0				= ((cdeltaf_@{co}/(1+cdeltaf_@{co}) *mcflex_@{co} + (cphih_@{co}* 1/(1+cdeltaf_@{co}))*mcflex_@{co})
					+((1-cphih_@{co})/(1+cdeltaf_@{co}))* pftotflex_@{co});
	0				= pcflex_@{co} ; 
	mcflex_@{co} 	= cfc_@{co}*(1/cfc_@{co}-crom_@{co})*(calfa_@{co}*rkflex_@{co}+(1-calfa_@{co})*wflex_@{co}-a_@{co})
					+cfc_@{co}*crom_@{co}*ppfflex_@{co};
	zcapflex_@{co}  =  (czcap_@{co}/(1-czcap_@{co}))* rkflex_@{co}  ; //++
	rkflex_@{co} 	= (wflex_@{co})+labflex_@{co}-kflex_@{co} ;
	kflex_@{co} 	= kpflex_@{co}(-1)+zcapflex_@{co} ; //++
	inveflex_@{co} 	= (1/(1+cbetabar_@{co}*cgamma_@{co}))* (inveflex_@{co}(-1) 
					+cbetabar_@{co}*cgamma_@{co}*inveflex_@{co}(1)+(1/(cgamma_@{co}^2*csadjcost_@{co}))*(pkflex_@{co}-pcflex_@{co})) +qs_@{co} ;
	pkflex_@{co} = -rrflex_@{co}-b_@{co} +(1-cbetabar_@{co}*(1-ctou_@{co}))*rkflex_@{co}(1)
					+cbetabar_@{co}*(1-ctou_@{co})*pkflex_@{co}(1)  ;
	cboldflex_@{co} = (chabb_@{co}/cgamma_@{co}/(1+chabb_@{co}/cgamma_@{co}))*cboldflex_@{co}(-1) 
					+(1/(1+chabb_@{co}/cgamma_@{co}))*cboldflex_@{co}(+1) +((csigma_@{co}-1)*cwhlc_@{co}/(csigma_@{co}*(1+chabb_@{co}/cgamma_@{co})))
					*(labflex_@{co}-labflex_@{co}(+1)) 
					- ((1-chabb_@{co}/cgamma_@{co})/(csigma_@{co}*(1+chabb_@{co}/cgamma_@{co})))*(rrflex_@{co}+b_@{co}) ;
	cboldflex_@{co}=cflex_@{co};//++
	yflex_@{co} 	= ctoy_@{co}*cboldflex_@{co}+itoy_@{co}*inveflex_@{co}+g_@{co}+crkky_@{co}/cgamma_@{co}*zcapflex_@{co}
					+mtoy_@{co}*(netxflex_@{co})+(crom_@{co})*yflex_@{co} ;	
	yflex_@{co} 	= cfc_@{co}*( calfa_@{co}*kflex_@{co}+(1-calfa_@{co})*labflex_@{co} +a_@{co} );//++
	wflex_@{co} 	= csigl_@{co}*labflex_@{co}+(1/(1-chabb_@{co}/cgamma_@{co}))*cboldflex_@{co} 
					- (chabb_@{co}/cgamma_@{co}/(1-chabb_@{co}/cgamma_@{co}))*cboldflex_@{co}(-1) ;
	kpflex_@{co} =  ((1-ctou_@{co})/cgamma_@{co})*kpflex_@{co}(-1)+(1-(1-ctou_@{co})/cgamma_@{co})*inveflex_@{co}
					+ (1-(1-ctou_@{co})/cgamma_@{co}) *(cgamma_@{co}^2)*csadjcost_@{co} *qs_@{co} ;
	cfflex_@{co}	=cflex_@{co}-clambda_@{co}*(cphih_@{co}*(pftotflex_@{co}-mcflex_@{co})/(1+cdeltaf_@{co}))
					-comegac_@{co}*clambda_@{co}*(cfflex_@{co}-cflex_@{co}-(cfflex_@{co}(-1)-cflex_@{co}(-1)))
					+cbeta_@{co}*comegac_@{co}*clambda_@{co}*(cfflex_@{co}(1)-cflex_@{co}(1)-(cfflex_@{co}-cflex_@{co}));
	invefflex_@{co}=inveflex_@{co}-clambda_@{co}*(cphih_@{co}*(pftotflex_@{co}-mcflex_@{co})/(1+cdeltaf_@{co}))
					-comegai_@{co}*clambda_@{co}*(invefflex_@{co}-inveflex_@{co}
					-(invefflex_@{co}(-1)-inveflex_@{co}(-1)))
					+cbeta_@{co}*comegai_@{co}*clambda_@{co}*(invefflex_@{co}(1)-inveflex_@{co}(1)-(invefflex_@{co}-inveflex_@{co}));
	xfflex_@{co}	=xhflex_@{co}-clambdax_@{co}*(-pxboldflex_@{co}+pmboldflex_@{co})-clambdax_@{co}*comegax_@{co}*
							(xfflex_@{co}-xhflex_@{co}-(xfflex_@{co}(-1)-xhflex_@{co}(-1)))+
							cbeta_@{co}*comegax_@{co}*clambdax_@{co}*(xfflex_@{co}(1)-xhflex_@{co}(1)-(xfflex_@{co}-xhflex_@{co}));
	mhflex_@{co}	=cphimh_@{co}*((1-cphih_@{co})*(ctoy_@{co}*cfflex_@{co}+itoy_@{co}*invefflex_@{co})
					/(mtoy_@{co}*cphimh_@{co}*(1+cdeltaf_@{co}))
					+(1-cphif_@{co})*yflex_@{co})+(1-cphimh_@{co})*xfflex_@{co};
	pmboldflex_@{co}=(cphif_@{co}*pftotflex_@{co}+(1-cphif_@{co})*ppfflex_@{co});
	netxflex_@{co}	=xhflex_@{co}-mhflex_@{co};
//************************************************************************************************	
// Sticky price - wage economy
//************************************************************************************************
//Symmetric equations
	//Euler ++
	//non-oil consumption
	c_@{co}		=cbold_@{co};
	//Investment++
	inve_@{co} = (1/(1+cbetabar_@{co}*cgamma_@{co}))
				* (inve_@{co}(-1) + cbetabar_@{co}*cgamma_@{co}*inve_@{co}(1)
				+(1/(cgamma_@{co}^2*csadjcost_@{co}))*(pk_@{co}-pc_@{co}))+qs_@{co};
	//capital accumulation ++ ++
	k_@{co}		=  kp_@{co}(-1)+zcap_@{co} ;
	kp_@{co} 	= ((1-ctou_@{co})/cgamma_@{co})*kp_@{co}(-1)+(1-(1-ctou_@{co})/cgamma_@{co})*inve_@{co} 
				+ (1-(1-ctou_@{co})/cgamma_@{co}) *(1+cbetabar_@{co})*csadjcost_@{co} *qs_@{co} ;
	//capital utilization rate++
	zcap_@{co} 	=  (czcap_@{co}/(1-czcap_@{co}))* rk_@{co} ;
	//wage setting ++
	w_@{co} 	=  (1/(1+cbetabar_@{co}*cgamma_@{co}))*w_@{co}(-1)
				+(cbetabar_@{co}*cgamma_@{co}/(1+cbetabar_@{co}*cgamma_@{co}))*w_@{co}(1)
				+(cindw_@{co}/(1+cbetabar_@{co}*cgamma_@{co}))*pinfc_@{co}(-1)
				-((1+cbetabar_@{co}*cgamma_@{co}*cindw_@{co})/(1+cbetabar_@{co}*cgamma_@{co}))*pinfc_@{co}
				+((cbetabar_@{co}*cgamma_@{co})/(1+cbetabar_@{co}*cgamma_@{co}))*pinfc_@{co}(1)
				+((1-cindw_@{co})/(1+cbetabar_@{co}*cgamma_@{co}))*piobj_@{co}
				-((1-cindw_@{co})*cbetabar_@{co}*cgamma_@{co}/(1+cbetabar_@{co}*cgamma_@{co}))*piobj_@{co}(+1)
				+(1-cprobw_@{co})*(1-cbetabar_@{co}*cgamma_@{co}*cprobw_@{co})/((1+cbetabar_@{co}*cgamma_@{co})*cprobw_@{co}
				 *(((clambdaw_@{co}+1)/clambdaw_@{co})*csigl_@{co}+1))*
				(csigl_@{co}*lab_@{co} + (1/(1-chabb_@{co}/cgamma_@{co}))*cbold_@{co} - ((chabb_@{co}/cgamma_@{co})/(1-chabb_@{co}/cgamma_@{co}))*cbold_@{co}(-1) -w_@{co}) 
				  + 1*sw_@{co} ;
	//production+
	y_@{co} 	= cfc_@{co}*(calfa_@{co}*k_@{co}+(1-calfa_@{co})*lab_@{co} +a_@{co} );
	//return on capital++
	rk_@{co} 	=  w_@{co}+lab_@{co}-k_@{co} ;
	//marginal costs modified for the inclusion of foreign inputs+
	mc_@{ co } 	=  cfc_@{co}*(1/cfc_@{co}-crom_@{co})*(calfa_@{co}*rk_@{co}+(1-calfa_@{co})*w_@{co} 
			- 1*a_@{co})+cfc_@{co}*(crom_@{co}*ppf_@{co}) ; 
	//composite consumer relative prices 
	0			=(1)/(1+cdeltaf_@{co})*((cphih_@{co}+cdeltaf_@{co})*ph_@{co}+(1-cphih_@{co})*pftot_@{co})
				                            + (1-cphih_@{ co })*( comega_@{ co }*(cf_@{ co }-c_@{ co }-(cf_@{ co }(-1)-c_@{ co }(-1))) 
                            - cbeta_@{ co }*comega_@{ co }*(cf_@{ co }(+1)-c_@{ co }(+1)-(cf_@{ co }-c_@{ co })) )+sp_@{co};
	//			+cphioil_@{co}*poild_@{co};
	0 			= pc_@{co} + sp_@{co}; 
	//home inflation++
	pinf_@{co}-piobj_@{co} 	=  (1/(1+cbetabar_@{co}*cgamma_@{co}*cindp_@{ co })) * (cbetabar_@{co}*cgamma_@{co}*(pinf_@{co}(1)-piobj_@{co}(1)) 
				+cindp_@{co}*(pinf_@{co}(-1) -piobj_@{co})
				+((1-cprobp_@{ co })*(1-cbetabar_@{co}*cgamma_@{co}*cprobp_@{ co })/cprobp_@{ co })
				*(celastpdt_@{ co }-1-cdeltaf_@{ co })*(mc_@{ co }-ph_@{ co })/(curvp_@{ co }+celastpdt_@{ co }-1))
				+ cbetabar_@{co}*cgamma_@{co}*cindpf_@{co}/(1+cbetabar_@{co}*cgamma_@{co}*cindpf_@{co})*(piobj_@{co}(+1)-piobj_@{co})
				+spinf_@{co}-cnup_@{co}*ep_@{co} ;
	pinf_@{co}-pinfc_@{co}=ph_@{co}-ph_@{co}(-1);//++
	cbold_@{co} = ((chabb_@{co}/cgamma_@{co})/(1+chabb_@{co}/cgamma_@{co}))*cbold_@{co}(-1) + (1/(1+chabb_@{co}/cgamma_@{co}))*cbold_@{co}(1)
				+((csigma_@{co}-1)*cwhlc_@{co}/(csigma_@{co}*(1+chabb_@{co}/cgamma_@{co})))*(lab_@{co}-lab_@{co}(1))
				- ((1-chabb_@{co}/cgamma_@{co})/(csigma_@{co}*(1+chabb_@{co}/cgamma_@{co})))*(r_@{co}-pinfc_@{co}(1)-(piobj_@{co}-piobj_@{co}(+1))+b_@{co}) ;
	//real value of capital stock ++
	pk_@{co} 	=-r_@{co}+pinfc_@{co}(1)+piobj_@{co}-piobj_@{co}(+1)+cbetabar_@{co}*(1-ctou_@{co})*pk_@{co}(1)-b_@{co} 
				+(1-cbetabar_@{co}*(1-ctou_@{co}))*rk_@{co}(1);
	//monetary policy rule ++
	@# if co != nth_ch
	// if not China:
//total consumption
	//monetary policy rule ++			
	r_@{co}	-piobj_@{co}	=crr_@{co}*(r_@{co}(-1)-piobj_@{co}(-1))
							+(1-crr_@{co})*(crpi_@{co}*(pinfc_@{co}-piobj_@{co})
							+cry_@{co}*(y_@{co}-yflex_@{co}))+crdy_@{co}*(y_@{co}-y_@{co}(-1)-(yflex_@{co}-yflex_@{co}(-1)))+ms_@{co};
	@# else 
	//if China:
	//monetary policy rule ++
	r_@{co}-piobj_@{co}		=crr_@{co}*(r_@{co}(-1)-piobj_@{co}(-1))+(1-crr_@{co})*(crpi_@{co}*(pinfc_@{co}-piobj_@{co})+cry_@{co}*(y_@{co}-yflex_@{co}))+crdy_@{co}*(y_@{co}-y_@{co}(-1)-(yflex_@{co}-yflex_@{co}(-1)))
				//+cruip_ch*(cbetax_ch_ea*deltas_ch_ea+cbetax_ch_us*deltas_ch_us)+ms_@{co}+cmpreq*ereg;
				//+cruip_ch*(seeuro_ch*deltas_ch_ea+seusd_ch*deltas_ch_us)
				+ms_@{co}
				//+cmpreq*ereg
				;
	@#endif
		//resource constraint
	y_@{co}		=ctoy_@{co}*cbold_@{co}+itoy_@{co}*inve_@{co}+g_@{co}+crk_@{co}/cgamma_@{co}*cky_@{co}*zcap_@{co}
				//+mtoy_@{co}*(xh_@{co}-mbold_@{co})
				+mtoy_@{co}*netx_@{co}
				+(crom_@{co})*y_@{co}; 
	//Total prices
	pinff_@{co}-pinfc_@{co}=pftot_@{co}-pftot_@{co}(-1)+spinff_@{co};		//++  
	pinffp_@{co}-pinfc_@{co}	=ppf_@{co}-ppf_@{co}(-1)+spinff_@{co};
	//demand for foreign consumption good ++
	cf_@{co}	=c_@{co}-clambda_@{co}*(cphih_@{co}*(pftot_@{co}-ph_@{co})/(1+cdeltaf_@{co}))
				-comegac_@{co}*clambda_@{co}*(cf_@{co}-c_@{co}-(cf_@{co}(-1)-c_@{co}(-1)))
				+cbeta_@{co}*comegac_@{co}*clambda_@{co}*(cf_@{co}(1)-c_@{co}(1)-(cf_@{co}-c_@{co}));
	//demand for foreign investment good ++
	invf_@{co}	=inve_@{co}-clambda_@{co}*(cphih_@{co}*(pftot_@{co}-ph_@{co})/(1+cdeltaf_@{co}))
				-comegai_@{co}*clambda_@{co}*(invf_@{co}-inve_@{co}-(invf_@{co}(-1)-inve_@{co}(-1)))
				+cbeta_@{co}*comegai_@{co}*clambda_@{co}*(invf_@{co}(1)-inve_@{co}(1)-(invf_@{co}-inve_@{co}));
	//demand for transit good +
	xf_@{co}	=xh_@{co}-clambdax_@{co}*(pmbold_@{co}-pxbold_@{co})-clambdax_@{co}*comegax_@{co}*
							(xf_@{co}-xh_@{co}-(xf_@{co}(-1)-xh_@{co}(-1)))+
							cbeta_@{co}*comegax_@{co}*clambdax_@{co}*(xf_@{co}(1)-xh_@{co}(1)-(xf_@{co}-xh_@{co}));	
	//non-oil import ++
	mh_@{co}	=cphimh_@{co}*((1-cphih_@{co})*(ctoy_@{co}*cf_@{co}+itoy_@{co}*invf_@{co})
				/(mtoy_@{co}*cphimh_@{co}*(1+cdeltaf_@{co}))+(1-cphif_@{co})*y_@{co})+(1-cphimh_@{co})*xf_@{co};
	//total import price ++
	pmbold_@{co}=(cphif_@{co}*pftot_@{co}+(1-cphif_@{co})*ppf_@{co});
	//price of foreign consumption good++
	pdf_@{co}=pftot_@{co}/(1+cdeltaf_@{co})+cdeltaf_@{co}*ph_@{co}/(1+cdeltaf_@{co});	
	//net export including oil
	netx_@{co}=xh_@{co}-mh_@{co};
@#endfor 
//************************************************************************************
//Billateral export and import prices; Total export and import 
//************************************************************************************
//Billateral tarif on us_ch
tarif_us_sym_ch=0.9*tarif_us_sym_ch(-1)+e_tarif_us_sym_ch;
tarif_us_lim_ch=0.9*tarif_us_lim_ch(-1)+e_tarif_us_lim_ch;

//Limited trade war: EA and CH import freely from US, but face tarifs when exporting
//Limited trade war pp: EA and CH import freely from US, but CH face tarifs when exporting???
//Full trade war pp: EA and CH tarifs freely from US, but CH face tarifs when exporting???
//Export prices are undisturbed
@#for co in countries 
	@#for co2 in countries 
		@# if co != co2
		//exported inflation in foreign currency and foreign prices++
				pinfx_@{co}_@{co2}-piobj_@{co}	=1/(1+cbetabar_@{co}*cgamma_@{co}*cindpf_@{co}) 
								* (cbetabar_@{co}*cgamma_@{co}*(pinfx_@{co}_@{co2}(1)-piobj_@{co}(1)) +cindpf_@{co}*(pinfx_@{co}_@{co2}(-1) - piobj_@{co})
								+(((1-cprobpf_@{co2})*(1-cbetabar_@{co}*cgamma_@{co}*cprobpf_@{co2})/cprobpf_@{co2})
								/(curvp_@{co2}+celastpdt_@{co2}-1))
								*((celastpdt_@{co2}-1-cdeltaf_@{co2})*(mc_@{co}
								-rs_@{co}_@{co2}+xcrtrend_@{co}_@{co2})
							+cdeltaf_@{co2}*ph_@{co2}-(celastpdt_@{co2}-1)*px_@{co}_@{co2}))
								+ cbetabar_@{co}*cgamma_@{co}*cindpf_@{co}/(1+cbetabar_@{co}*cgamma_@{co}*cindpf_@{co})*(piobj_@{co}(+1)-piobj_@{co})
								+ cbetax_@{co}_@{co2}*(spinff_@{co2}); 
				pinfx_@{co}_@{co2}-cbetax_@{co}_@{co2}*pinfc_@{co2}=px_@{co}_@{co2}-px_@{co}_@{co2}(-1);		//++
				//exported inflation in foreign currency and foreign prices for production purposes
				pinfxp_@{co}_@{co2}-piobj_@{co}	=1/(1+cbetabar_@{co}*cgamma_@{co}*cindpf_@{co}) 
								* (cbetabar_@{co}*cgamma_@{co}*(pinfxp_@{co}_@{co2}(1)-piobj_@{co}(1)) +cindpf_@{co}*(pinfxp_@{co}_@{co2}(-1) -piobj_@{co})
								+(((1-cprobpf_@{co2})*(1-cbetabar_@{co}*cgamma_@{co}*cprobpf_@{co2})/cprobpf_@{co2})
								/(curvp_@{co2}+celastpdt_@{co2}-1))
								*((celastpdt_@{co2}-1)*(mc_@{co}-rs_@{co}_@{co2}+xcrtrend_@{co}_@{co2}) 
								-(celastpdt_@{co2}-1)*pxp_@{co}_@{co2}))
								+ cbetabar_@{co}*cgamma_@{co}*cindpf_@{co}/(1+cbetabar_@{co}*cgamma_@{co}*cindpf_@{co})*(piobj_@{co}(+1)-piobj_@{co})
								+ cbetax_@{co}_@{co2}*(spinff_@{co2})  ; 
				pinfxp_@{co}_@{co2}-cbetax_@{co}_@{co2}*pinfc_@{co2}=pxp_@{co}_@{co2}-pxp_@{co}_@{co2}(-1);		//	++
			@#endif
	@#endfor	
@#endfor
%// There is no China, so no need to adjust for trend in exchange rate
@#for co in chlist 
	@#for co2 in uslist 
		//imported inflation from home country point of view:
				//bilateral inflation
				pinffb_@{co}_@{co2}	-piobj_@{co}=(1/(1+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2}))  
								* (cbetabar_@{co2}*cgamma_@{co2}*(pinffb_@{co}_@{co2}(1)-piobj_@{co}(1))
								+cindpf_@{co2}*(pinffb_@{co}_@{co2}(-1)-piobj_@{co}) 
								+(((1-cprobpf_@{co})*(1-cbetabar_@{co2}*cgamma_@{co2}*cprobpf_@{co})/cprobpf_@{co})
								/(curvp_@{co}+celastpdt_@{co}-1))
								*((celastpdt_@{co}-1-cdeltaf_@{co})*(mc_@{co2}+rs_@{co}_@{co2}-xcrtrend_@{co}_@{co2} 
								+tarif_us_sym_ch)+cdeltaf_@{co}*ph_@{co}-(celastpdt_@{co}-1)*pfb_@{co}_@{co2}))
								+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2}/
								(1+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2})*(piobj_@{co}(+1)-piobj_@{co})
								+cbetam_@{co}_@{co2}*spinff_@{co};
				pinffb_@{co}_@{co2}-pinfc_@{co}	=pfb_@{co}_@{co2}-pfb_@{co}_@{co2}(-1);		//++ 
				// imported inflation for production components from home country point of view and in home currency++
				pinffp_@{co}_@{co2}-piobj_@{co} =  (1/(1+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2})) 
								*(cbetabar_@{co2}*cgamma_@{co2}*(pinffp_@{co}_@{co2}(1) -piobj_@{co}(1))+cindpf_@{co2}*(pinffp_@{co}_@{co2}(-1) - piobj_@{co})
								   +(((1-cprobpf_@{co})*(1-cbetabar_@{co2}*cgamma_@{co2}*cprobpf_@{co})/cprobpf_@{co})
								*(celastpdt_@{co}-1)/(curvp_@{co}+celastpdt_@{co}-1)
								*(mc_@{co2}+rs_@{co}_@{co2}-xcrtrend_@{co}_@{co2} 
								+tarif_us_sym_ch-ppf_@{co}_@{co2})))
								+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2}/
								(1+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2})*(piobj_@{co}(+1)-piobj_@{co})
								+cbetam_@{co}_@{co2}*spinff_@{co};
				pinffp_@{co}_@{co2}-pinfc_@{co}=ppf_@{co}_@{co2}-ppf_@{co}_@{co2}(-1);	//++  
			@#endfor
@#endfor
%//Again, no China here		
@#for co in uslist
		@#for co2 in chlist
			//imported inflation from home country point of view:
				//bilateral inflation
				pinffb_@{co}_@{co2}	-piobj_@{co}=(1/(1+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2}))  
								* (cbetabar_@{co2}*cgamma_@{co2}*(pinffb_@{co}_@{co2}(1)-piobj_@{co}(1))
								+cindpf_@{co2}*(pinffb_@{co}_@{co2}(-1)-piobj_@{co}(-1)) 
								+(((1-cprobpf_@{co})*(1-cbetabar_@{co2}*cgamma_@{co2}*cprobpf_@{co})/cprobpf_@{co})
								/(curvp_@{co}+celastpdt_@{co}-1))
								*((celastpdt_@{co}-1-cdeltaf_@{co})*(mc_@{co2}+rs_@{co}_@{co2}-xcrtrend_@{co}_@{co2}
								+tarif_us_lim_ch+tarif_us_sym_ch)
								+cdeltaf_@{co}*ph_@{co}-(celastpdt_@{co}-1)*pfb_@{co}_@{co2}))
								+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2}/
								(1+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2})*(piobj_@{co}(+1)-piobj_@{co}(+1))
								+cbetam_@{co}_@{co2}*spinff_@{co};
				pinffb_@{co}_@{co2}-pinfc_@{co}	=pfb_@{co}_@{co2}-pfb_@{co}_@{co2}(-1);		//++ 
			
				// imported inflation for production components from home country point of view and in home currency++
				pinffp_@{co}_@{co2}-piobj_@{co} =  (1/(1+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2})) 
								*(cbetabar_@{co2}*cgamma_@{co2}*(pinffp_@{co}_@{co2}(1) -piobj_@{co}(1))+cindpf_@{co2}*(pinffp_@{co}_@{co2}(-1) - piobj_@{co}(-1))
								   +(((1-cprobpf_@{co})*(1-cbetabar_@{co2}*cgamma_@{co2}*cprobpf_@{co})/cprobpf_@{co})
								*(celastpdt_@{co}-1)/(curvp_@{co}+celastpdt_@{co}-1)
								*(mc_@{co2}+rs_@{co}_@{co2}-xcrtrend_@{co}_@{co2}
								+tarif_us_lim_ch+tarif_us_sym_ch-ppf_@{co}_@{co2})))
								+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2}/
								(1+cbetabar_@{co2}*cgamma_@{co2}*cindpf_@{co2})*(piobj_@{co}(+1)-piobj_@{co}(+1))
								+cbetam_@{co}_@{co2}*spinff_@{co};
				pinffp_@{co}_@{co2}-pinfc_@{co}=ppf_@{co}_@{co2}-ppf_@{co}_@{co2}(-1);	//++  
		@#endfor
@#endfor
@#for co in countries 
	@#for co2 in countries 
		@# if co != co2	
		//bilateral positions
		//cbeta_@{co2}*nfa_@{co}_@{co2} =  (1/cgamma_@{co})*nfa_@{co}_@{co2}(-1) + mtoy_@{co}*(tb_@{co}_@{co2});
		pxbold_@{co}_@{co2} = (cphixh_@{co}* (cphif_@{co2}*px_@{co}_@{co2} + (1-cphif_@{co2})*pxp_@{co}_@{co2} + rs_@{co}_@{co2}-xcrtrend_@{co}_@{co2})
					+(1-cphixh_@{co})*pfb_@{co}_@{co2} );
					//+ cphixoil_@{co} *cbetaxoil_@{co}_@{co2}*poilhome_@{co};
		pmbold_@{co}_@{co2}=(cphif_@{co}*pfb_@{co}_@{co2}+(1-cphif_@{co})*ppf_@{co}_@{co2});
							//cphimoil_@{co}*cbetamoil_@{co}_@{co2}*(poilhome_@{co});
		@#endif
	@#endfor
@#endfor
//Total trade
tt_us_ch=mhb_us_ch+xhb_us_ch;
tt_ch_us=mhb_ch_us+xhb_ch_us;
cbeta_us*nfa_ch =  (1/cgamma_ch)*nfa_ch(-1) + mtoy_ch*(tb_ch);
ppf_us		=	cbetam_us_ch*ppf_us_ch;
ppf_ch		=	cbetam_ch_us*ppf_ch_us;
pftot_us	=	cbetam_us_ch*pfb_us_ch;
pftot_ch	=	cbetam_ch_us*pfb_ch_us;
//px_us	 	=	cbetax_us_ea*px_us_ea+cbetax_us_ch*px_us_ch;
//px_ch	 	=	cbetax_ch_ea*px_ch_ea+cbetax_ch_us*px_ch_us;
//"Imported" marginal cost in home currency

//The export price is set in foreign currency,transit good is in local currency, needs to be transformed into local currency
pxbold_us	=	cphixh_us*cbetax_us_ch*(cphif_ch*px_us_ch+(1-cphif_ch)*pxp_us_ch+rs_us_ch+xcrtrend_ch_us)
				+(1-cphixh_us)*pftot_us;
pxbold_ch	=	cphixh_ch*cbetax_ch_us*(cphif_us*px_ch_us+(1-cphif_us)*pxp_ch_us+rs_ch_us-xcrtrend_ch_us)
				+(1-cphixh_ch)*pftot_ch;
//Total Non-Oil Exports			
xh_us		=	cbetax_us_ch*xhb_us_ch+(snt_us); 
xh_ch		=	cbetax_ch_us*xhb_ch_us+(snt_ch); 
//******************************************************************************
//Individual country equations	
//Real exchange rate, eq (72) in 2-country paper ++
rs_ch_us	=	-rs_us_ch;
//New XCR rule
rs_ch_us-xcrtrend_ch_us=(1-cthetas_us_ch)*(rs_ch_us(1)-xcrtrend_ch_us(1))+cthetas_us_ch*(rs_ch_us(-1)-xcrtrend_ch_us(-1))
				-(r_ch+cthetauip_ch_us*(rs_ch_us-xcrtrend_ch_us))+r_us+pinfc_ch(1)-pinfc_us(1)-cronfa_us*nfa_ch
				+ss_ch_us;
//auxilarily variable for employment observation equation in EA++
//eempl_ea=eempl_ea(-1)+cbetabar_ea*cgamma_ea*(eempl_ea(+1)-eempl_ea)+(1-cprobe_ea)*(1-cprobe_ea*cbetabar_ea*cgamma_ea)*(lab_ea-eempl_ea)/cprobe_ea;
//Trade balance
tb_us	=	pxbold_us-pmbold_us+(netx_us);	
tb_ch	=	pxbold_ch-pmbold_ch+(netx_ch);	
//*********************************************************
//Shocks
//*********************************************************
@#for co in countries
	a_@{co} = crhoa_@{co}*a_@{co}(-1)  + ea_@{co}; %TFP
	b_@{co} = crhob_@{co}*b_@{co}(-1) + eb_@{co}; %risk premium
	g_@{co} = crhog_@{co}*g_@{co}(-1) + eg_@{co} + cgy_@{co}*ea_@{co};
	qs_@{co} = crhoqs_@{co}*qs_@{co}(-1) + eqs_@{co};
	ms_@{co} = crhoms_@{co}*ms_@{co}(-1) + em_@{co};
	spinf_@{co} = crhopinf_@{co}*spinf_@{co}(-1) + epinfma_@{co} -(crhopinf_@{co}-cmap_@{co})*epinfma_@{co}(-1); %price markup
	epinfma_@{co}=epinf_@{co};
	sw_@{co} = crhow_@{co}*sw_@{co}(-1) + ewma_@{co} - (crhow_@{co}-cmaw_@{co})*ewma_@{co}(-1) ; %wage markup
	ewma_@{co}=ew_@{co};
	sp_@{co}=crhop_@{co}*sp_@{co}(-1)+ep_@{co};
	snt_@{co}=cront_@{co}*snt_@{co}(-1)+cnua_@{co}*ea_@{co}-ent_@{co}; %rest of the world (export) demand
	spinff_@{co} = crhopinff_@{co}*spinff_@{co}(-1) + epinffma_@{co} -(crhopinff_@{co}-cmapf_@{co})*epinffma_@{co}(-1); %foreign price markup
	epinffma_@{co}=epinff_@{co};
	ctrendev_@{co}-0.9999*ctrendev_@{co}(-1)=crhotrend_@{co}*(ctrendev_@{co}(-1)-0.9999*ctrendev_@{co}(-2))+ectrenddev_@{co};
	dpiobj_@{co}=crhopiobj_@{co}*dpiobj_@{co}(-1)+epiobj_@{co};
	dpiobj_@{co}=piobj_@{co}-0.9999*piobj_@{co}(-1);
@#endfor
//International, rest of the world
xcrtrend_ch_us-0.9999*xcrtrend_ch_us(-1)=crhoxcrtrend*(xcrtrend_ch_us(-1)-0.9999*xcrtrend_ch_us(-2))+excrtrend;
xcrtrend_us_ch=-xcrtrend_ch_us;
rstrenddev_ch_us=erstrenddev;
ss_us_ch=crhoss_us_ch*ss_us_ch(-1)+es_us_ch;% UIRP exchange rate shock
ss_ch_us=-ss_us_ch;
//ssrreq=crhosrq*ssrreq(-1)+ereg;
//*****************************************************************************************
// Measurment equations
//*****************************************************************************************
@#for co in countries
dYER_@{co}=(1-crom_@{co})*(y_@{co}-y_@{co}(-1))+(ctrend_@{co}+ctrendev_@{co});
dPCR_@{co}=cbold_@{co}-cbold_@{co}(-1)+ctrend_@{co}+ctrendev_@{co};
dYED_@{co} = 1*(pinf_@{co}-piobj_@{co}) + dinftrend_@{co};
dinftrend_@{co}=constepinf_@{co};
dPCD_@{co} = (pinfc_@{co}-piobj_@{co}) + dinftrend_@{co}; 
NETTRADE_@{co}=mtoy_@{co}*(xh_@{co}-mh_@{co})+constent_@{co};
@#endfor
	@#for co in countries3
	dITR_@{co}=inve_@{co}-inve_@{co}(-1)+ctrend_@{co}+ctrendev_@{co};
	dWC_@{co}=w_@{co}-w_@{co}(-1)+ctrend_@{co}+ctrendev_@{co};
	dMTD_@{co}=pmbold_@{co}-pmbold_@{co}(-1)+pinfc_@{co}-piobj_@{co}+constem_@{co};
@#endfor
dITR_ch=inve_ch-(rs_ch_us-xcrtrend_ch_us)-inve_ch(-1)+(rs_ch_us(-1)-xcrtrend_ch_us(-1))+ctrend_ch+ctrendev_ch; //CH Investment in US dollars
//dEMPL_ea = eempl_ea-eempl_ea(-1) + constelab_ea;
dLAB_us=lab_us-lab_us(-1)+constelab_us;
STI_ch =   (r_ch + conster_ch+piobj_ch); 
dEXCRN_ch_us=rs_ch_us-rs_ch_us(-1)-(pinfc_us-piobj_us)+pinfc_ch-piobj_ch+xcrtrend_ch_us-xcrtrend_ch_us(-1); %\\ea-us nominal exchange rate
FEDFUND_us =    4*(r_us + conster_us+piobj_us);

end;
//resid(1);
//steady;
//model_diagnostics;
//model_info (lik_init = 2);
//check;

shocks;

//corr ea, eastar = 0.067;
//corr eb, ebstar = 0.194;
//corr em, emstar = 0.326;
//corr epinff, epinffstar = 0.537;
//corr ent, entstar = -0.144;

var es_us_ch; stderr 0.7;

var ea_us; stderr 0.476;
var eb_us; stderr 0.7476;
var eg_us; stderr 0.4470;
var eqs_us;stderr 0.2687;
var em_us;stderr 0.2349;
var epinf_us; stderr 0.1313;
var ew_us; stderr 0.3793;
var ep_us; stderr 0.1717;
//var epinff_us; stderr 0.1705;
var ent_us; stderr 1.41;

var ea_ch; stderr 0.47;
var eb_ch; stderr 5;
var eg_ch; stderr 1;
var eqs_ch;stderr 5;
var em_ch;stderr 0.2349;
var epinf_ch; stderr 0.1313;
var ew_ch; stderr 0.3793;
var ep_ch; stderr 0.1717;
//var epinff_ch; stderr 0.1705;
//var ent_ch; stderr 1.41;
var ent_ch; stderr 1;
//var ereg; stderr 0.1;
//var erstrenddev; stderr 0.1;
//var ereqtrend; stderr 0.1;
//var excrtrend; stderr 0.1;
//var	epiobj_ch	;	stderr	10^(-2);



//var e_trend_ch; stderr	10^(-10);
//var e_tarif_us_lim; stderr	10;
//var e_tarif_us_lim_ch; stderr	10;
//var e_tarif_us_sym_ch; stderr	10;
//var e_tarif_us_sym_chea; stderr	10;
//var e_tarif_us_full; stderr	10;
end;
estimated_params;
// PARAM NAME, INITVAL, LB, UB, PRIOR_SHAPE, PRIOR_P1, PRIOR_P2, PRIOR_P3, PRIOR_P4, JSCALE
// PRIOR_SHAPE: BETA_PDF, GAMMA_PDF, NORMAL_PDF, INV_GAMMA_PDF
stderr ea_us,		0.5,	0.05,4,INV_GAMMA_PDF,0.2,2;
//stderr eb_us,		0.8,	0.05,4,INV_GAMMA_PDF,0.2,2;
stderr eb_us,		0.8,	0.05,0.9,INV_GAMMA_PDF,0.2,2;
stderr eg_us,		0.5,	0.01,4,INV_GAMMA_PDF,0.2,2;//
stderr eqs_us,		0.3,	0.05,4,INV_GAMMA_PDF,0.2,2;
stderr em_us,		0.2,	0.0,4,INV_GAMMA_PDF,0.2,2;
stderr epinf_us,	0.15,	0.05,4,INV_GAMMA_PDF,0.2,2;
stderr ew_us,		0.4,	0.05,4,INV_GAMMA_PDF,0.2,2;
stderr ep_us,		0.17,	0.05,4,INV_GAMMA_PDF,0.2,2;
//stderr epinff_us,1.45,  	0.05,17,INV_GAMMA_PDF,0.2,2;
//stderr epinff_us,	1.45,  	0.05,4,INV_GAMMA_PDF,0.2,2;
stderr ent_us,		1.5,	0.05,4,INV_GAMMA_PDF,0.2,2;

stderr ea_ch,			0.5,	0.05,4,INV_GAMMA_PDF,0.5,0.5;
//stderr ea_ch,			0.5,	0.05,4,INV_GAMMA_PDF,0.2,2;
//stderr ea_ch,			0.5,	0.05,0.3,INV_GAMMA_PDF,0.2,2;
//stderr ea_ch,			0.5,	0.05,0.3,INV_GAMMA_PDF,0.2,2;
stderr eb_ch,			0.5,	0.05,4,INV_GAMMA_PDF,0.2,2;
stderr eg_ch,			0.32,	0.01,4,INV_GAMMA_PDF,0.2,2;
stderr epinf_ch,		0.11,	0.05,4,INV_GAMMA_PDF,0.2,0.2;
stderr ep_ch, 			0.2,	0.00001, 4, INV_GAMMA_PDF,0.2,2;
stderr eqs_ch,			0.11,	0.05,4,INV_GAMMA_PDF,0.2,0.2;
//stderr em_ch,			0.2,	0.05,4, INV_GAMMA_PDF,0.2,2;
stderr em_ch,			0.2,	0.05,4, INV_GAMMA_PDF,0.2,2;
stderr ent_ch,			1.5,	0.05,10,INV_GAMMA_PDF,0.2,2;
stderr epiobj_ch,		0.1,	0.00001,	10,INV_GAMMA_PDF,0.2,2;
stderr excrtrend,		0.1,	0.001,	10,INV_GAMMA_PDF,0.2,2;

stderr es_us_ch, 	1, 	0	, 10	,	INV_GAMMA_PDF	,	0.2,	2;
corr  ea_us, ea_ch,         0.1    ,        ,        , beta_pdf    ,    0.5    ,    0.2;
corr  eb_us, eb_ch,         0.1    ,        ,        , beta_pdf    ,    0.5    ,    0.2;
corr  em_us, em_ch,         0.1    ,        ,        , beta_pdf    ,    0.5    ,    0.1;
corr ent_us, ent_ch,        0.1    ,        ,        , beta_pdf    ,  	0.5    ,    0.1;

crhoa_us,		0.8,		0.01, 0.999,beta_pdf,		0.5	,	0.2;
crhob_us,		0.7,		0.7,0.999,BETA_PDF,		0.5,	0.2;
crhog_us,		0.9,		0.01,0.975,BETA_PDF,		0.5,	0.20;
crhoqs_us,		0.6,		0.01,0.999,BETA_PDF,		0.5,	0.2;
crhoms_us,		0.2,		0.01,0.999,beta_pdf,		0.5,	0.2;
crhopinf_us,	        0.9,		0.01,0.99,beta_pdf,			0.5	,	0.2; 
crhop_us,		0.7,		0.01,0.99999,beta_pdf,		0.5	,	0.2; 
crhow_us,		0.5,		0.1,0.975,BETA_PDF,		0.5,	0.20;
cmap_us,		0.1,		0.01,0.99,BETA_PDF	,	0.1,    0.04;
cmaw_us,		0.1,		0.01,0.99,beta_pdf	,	0.1	,	0.04;

cront_us, 		0.9,		0.01,0.99,beta_pdF,		0.5	,	0.2;
cnup_us, 		0.33,		0.01,0.99,BETA_PDF	,	0.5,	0.2;
cnua_us, 		0.83,		0.01,0.99,beta_pdf	,	0.5	,	0.2; //Troublemaker
cgy_us, 		0.54,		0.01,0.975,BETA_PDF	,	0.5,	0.2;
crhoss_us_ch, 		0.85,		0.01,0.999,BETA_PDF		,	0.7,	0.15;

//here will be trends
constelab_us,		-0.1,		-0.5,	0.5,		normal_pdf	,	-0.1	,	0.1;
constent_us,		-2.3,		-5.0,	5, 			NORMAL_PDF,		-2, 	0.1;
constepinf_us,		0.49,		0.1,	2.0,		NORMAL_PDF,		0.5,	0.1;

constent_ch,		2,			,	, 	NORMAL_PDF,		2, 	0.5;
constepinf_ch,		0.1,	0.1,	2.0,		NORMAL_PDF,		0.3,	0.2;
ctrend_ch,		2,		1,	4,	NORMAL_PDF,		2,	0.5;
//consters_ea_us,		0	,			,	, normal_pdf	,	0	,	0.1;

//Structural Parameters
cthetas_us_ch, 		0.1,		0.01,	0.9999,	BETA_PDF,		0.3,	0.1;

csadjcost_us,	4       ,	0       ,	20      ,	normal_pdf	,	4	,	1.5;	
csigma_us,		1.5,		0.5		,	2		,	gamma_pdf	,	1.5	,	0.25;	
csigl_us,		2.05	,	1	    ,	5.00	,	normal_pdf	,	2	,	0.75;	
chabb_us,		0.7	,		0.3     ,	0.95	,	beta_pdf	,	0.6	,	0.1;
cfc_us,			1.5	,		1       ,	2.00	,	normal_pdf	,	1.25,	0.15;
cprobw_us,		0.74	,	0.01	,	0.99	,	beta_pdf	,	0.5	,	0.15;		
cindw_us,		0.15	,	0.01	,	0.99	,	beta_pdf	,	0.5	,	0.15;	
cprobp_us,		0.80	,	0.01	,	0.99	,	beta_pdf	,	0.5	,	0.15;
cindp_us,		0.25	,	0.01	,	0.99	,	beta_pdf	,	0.5	,	0.15;
czcap_us,		0.02	,	0.001	,	0.99	,	beta_pdf	,	0.5	,	0.15;
calfa_us,		0.3		,	0.01	,	1.0		,	NORMAL_PDF	,	0.3	,	0.03;
constbeta_us,	0.15	,	0.01	,	0.99	,	gamma_pdf	,	0.25,	0.1;
crr_us,			0.9	  	,	0.02	,	0.99	,	beta_pdf	,	0.75,	0.1;	
crpi_us,		1.5     ,	1       ,	2.5     ,	normal_pdf	,	1.5	,	0.15;	
cry_us,			0.1		,	0.01	,	0.5     ,	normal_pdf	,	0.1	,	0.03;
crdy_us, 		0.13	,	0.01	,	0.5     ,	normal_pdf	,	0.1	,	0.03;
crom_us, 		0.1		,	0.01	,	0.99	,	normal_pdf	,	0.06,	0.02;	
cdeltaf_us,		0.1		,	0.01	,	4       ,	gamma_pdf	,	0.7	,	0.5;		
cprobpf_us, 	0.6		,	0.01	,	0.8	,	beta_pdf	,	0.5	,	0.15;	
cindpf_us, 		0.30	,	0.01	,	0.99	,	beta_pdf	,	0.5	,	0.15;	
clambda_us, 	3       ,	0.1     ,	15      ,	gamma_pdf	,	3	,	1;		
comega_us	,	4       ,	0       ,	20      ,	normal_pdf	,	4	,	1;
clambdaim_us, 	3       ,	0.1     ,	15      ,	gamma_pdf	,	3	,	1;		
comegaim_us	,	4       ,	0       ,	20      ,	normal_pdf	,	4	,	1;
//China
crhoxcrtrend, 0.5,		0.00001,0.975,BETA_PDF,	0.3	,	0.1;
crhopiobj_ch, 0.7,		0.00001,0.999,BETA_PDF,	0.3	,	0.1;
crhop_ch, 0.9,		0.00001,0.99999,BETA_PDF,	0.6	,	0.1;
crhoa_ch,		0.8,		0.01,0.999,beta_pdf	,	0.5	,	0.1;
crhob_ch,		0.8,		0.01,0.999,BETA_PDF,		0.5,	0.2;
crhoqs_ch,		0.8,		0.01,0.999,BETA_PDF,		0.4,	0.2;
crhoms_ch,		0.8,		0.01,0.99999,beta_pdf	,	0.5	,	0.2;
crhopinf_ch,	0.8,		0.01,0.975,beta_pdf	,		0.5	,	0.1;
cmap_ch,		0.1,		0.01,0.9999,BETA_PDF	,	0.5,    0.2;
cnup_ch, 		0.3,		0.001,0.9999,BETA_PDF	,	0.5,	0.2;
cnua_ch, 		0.6,		0.1,0.9,			beta_pdf	,	0.6	,	0.2;
cgy_ch, 		0.6,		0.01,0.9999,		BETA_PDF	,	0.6,	0.1;
cront_ch, 		0.9,		0.01,0.99			,beta_pdF,		0.6	,	0.1;

csadjcost_ch,		3,			0,		20,		NORMAL_PDF, 	3	,	0.5;
csigma_ch,			1.1,		0.5,	2,		gamma_pdf	,	1	,	0.1;
csigl_ch,			2.05,		0.5,	3.5,	NORMAL_PDF,		2,		0.5;
chabb_ch,			0.3,		0.1,	0.95,	beta_pdf	,	0.3	,	0.1;	
cfc_ch,				1.45,		0,		4, 		NORMAL_PDF,		1.5,	0.1;
cprobw_ch,			0.7,		0.01,	0.99,	BETA_PDF,		0.5,	0.150;
cindw_ch,			0.4,		0.01,	0.99,	beta_pdf	,	0.5	,	0.15;	
cprobp_ch,			0.8,		0.01,	0.99,	beta_pdf	,	0.8	,	0.1;	
cindp_ch,			0.6,		0.01,	0.99,	beta_pdf	,	0.5	,	0.15;	
czcap_ch,			0.3,		10^(-6),0.99,	BETA_PDF,		0.5,	0.2;

calfa_ch,			0.3,		0.01,	1.0,	NORMAL_PDF,		0.3,	0.1;
cprobpf_ch, 		0.50,		0.01	,	0.99	,	beta_pdf	,	0.5	,	0.15;	
cindpf_ch, 			0.30,		0.01	,	0.99	,	beta_pdf	,	0.5	,	0.15;
crdy_ch, 			0.2,		0.001	,	0.5     ,	normal_pdf	,	0.15	,	0.1;
clambda_ch, 		1.5,		0.3     ,	15      ,	gamma_pdf	,	3	,	1;	
comega_ch,			4,			0       ,	20      ,	normal_pdf	,	4	,	1;
clambdaim_ch, 		1.5,		0.3     ,	15      ,	gamma_pdf	,	3	,	1;	
comegaim_ch,		4,			0       ,	20      ,	normal_pdf	,	4	,	1;
crom_ch,	 		0.1,		0.0001	,	0.9		,	normal_pdf	,	0.1	,	0.01;	
cdeltaf_ch,			0.9	,		0.01	,	0.9,		gamma_pdf	,	0.7	,	0.1;
cthetauip_ch_us, 	0.5,		10^(-6),	0.9,		normal_PDF,		0.5,	0.2; 
end;

varobs 
dYER_us dPCR_us dITR_us NETTRADE_us dLAB_us dWC_us FEDFUND_us   dPCD_us dYED_us   
dYER_ch dPCR_ch	dITR_ch NETTRADE_ch	STI_ch		dPCD_ch	dYED_ch  dEXCRN_ch_us  
;

identification(advanced=1);
//identification(ar=10);

//estimated_params_init(use_calibration);
//end;
estimation(mode_compute=0,mode_file =usedata_mode, prior_trunc=0,graph_format=pdf, plot_priors=0, datafile=data, xls_sheet=Sheet1, xls_range=A1:CB102, first_obs=1,presample=15, 
prefilter=0, mh_replic=0, mh_nblocks=10, 
//mh_replic=100000, mh_nblocks=10, 
//, load_mh_file ,mh_jscale=0.20, 
mh_drop=0.2, lik_init=2, nodisplay 
//, mh_recover
//, load_results_after_load_mh //,silent_optimizer 
//, mode_check
 );
 
stoch_simul(periods=2100, irf=40, irf_shocks=(em_ch))  pinfc_ch pinf_ch pinff_ch pinffb_ch_us r_ch rs_ch_us ms_ch mc_ch w_ch lab_ch rk_ch inve_ch;
